%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                       %
% Übung: cfg_zu_dcg_1                                                   % 
%                                                                       %
% Aufgabe 1)                                                            %
% Übertrage die folgende kontextfreie Sprache in eine Prolog DCG.       %
%        S → A, S, B                                                    %
%        S → ε                                                          %
%        A → a                                                          %
%        B → b                                                          %
%                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%% Erläuterung zu Aufgabe 1)
%
% DCG's können in Prolog einfach dargestellt werden.
% Nichtterminale werden kleingeschrieben und Terminale stehen kleingeschrieben in einer Liste.
% Die Übergänge werden durch einen Pfeil bestehend aus zwei Bindestrichen und dem größer-Zeichen dargestellt: -->
% Eine Grammatikregel der Form C → c sieht in Prolog-Notation also so aus: c --> [c].
% Das leere Wort wird als leere Liste dargestellt.
% Bei dieser DCG-Darstellung in Prolog handelt es sich um “notational sugar”.
% DCG-Klauseln werden intern umgewandelt in Klauseln mit Differenzlisten (siehe Foliensatz 7 Seite 9). 

%
%%% Lösung Aufgabe 1)

start --> [].              % S → ε
start --> a, start, b.     % S → A, S, B
a --> [a].                 % A → a
b --> [b].                 % B → b

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                       %
% Aufgabe 2)                                            %
% Welche Sprache wird von der Grammatik generiert?      %
%                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%% Erläuterung zu Aufgabe 2)
% 
% Das Start-Symbol unserer Grammatik führt entweder zu dem leeren Wort 
% oder zu den Nichtterminalen A,S und B, wobei S wieder das Start-Symbol ist.
% Nichtterminal A führt zu dem Buchstaben a und Nichtterminal B zum Buchstaben b.
% Es ist in dieser Sprache also möglich, das leere Wort oder eine 
% beliebige Anzahl an a's gefolgt von derselben Anzahl an b's zu generieren.
% Um die beliebige Anzahl der Buchstaben inbegriffen dem leeren Wort darzustellen wird normalerweise der Kleene-Stern (*) verwendet.
% Bei unserer Sprache muss jedoch zusätzlich noch definiert werden, dass die Anzahl von a's und b's identisch sein muss.
% Hierfür benutzen wir das hochgestellte n hinter beiden Buchstaben und definieren n als größer-gleich 0.

%
%%% Lösung Aufgabe 2)

% Die gegebene Grammatik generiert die Sprache L = {a^nb^n | n ≥ 0}.


%
%% Testen (optional)
% Diese Tests kannst du manuell in deinem Prolog Interpreter durchführen.

% ?- start([a,a,a,b,b,b],[]).
% -> true.

% ?- start([a,b],[]).
% -> true.

% Anfrage, um alle möglichen Palindrome zu generieren:
% ?- start(X,[]).

