%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                               %
% Übung: erweiterte Grammatik                                   %
%                                                               %
% Aufgabe 1)                                                    %
% Erweitere die Grammatik mit den Regeln:                       %
% S → NP VP, NP → Det N, VP → V NP,                             %
% Det → eine|die|keine, N → katze|maus, V → jagt|klaut          %
% um Regeln, für                                                %
%     • Adjektive (klein, schnell,. . . ) und                   %
%     • Konjunktionen (und, oder)                               %
%                                                               %
% Implementiere deine Grammatik als DCG in Prolog. Speichere    % 
% deine Grammatik in einer eigenen Datei. Wir werden sie in     %
% den kommenden Wochen erweitern und zusätzliche Prädikate      %
% definieren, die die Arbeit mit der Grammatik vereinfachen.    %
%                                                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%
%% Erläuterung zu Aufgabe 1)
% Die in der Aufgabenstellung gegebene Grammatik in Prolog-Notation findest du auf Seite 10 von Foliensatz 7.
% Diese Grammatik ist bisher nur dazu fähig, simple Sätze der Form [Det, Nomen, Verb, Det, Nomen] im Singular zu bilden.
% Nun ist unser Ziel, die Adjektive "kleine" und "schnelle" (im Femininum, da unsere Nomen alle feminin sind)
% und die Konjunktionen "und" und "oder" hinzuzufügen.

% Adjektive:
% Zuerst müssen die beiden Adjektive in das Lexikon eingetragen werden. 
% Nun geht es darum, unserer Grammatik die passenden Regeln hinzuzufügen, mit welchen
% sich grammatische Sätze mit Adjektiven bilden lassen.
% Hierbei muss beachtet werden, dass Adjektive belibig oft nacheinander auftreten können.
% Es reicht also nicht, nur die Grammatikregel der Nominalphrase so zu verändern, dass ein
% Adjektiv zwischen Determinierer und Nomen steht, sondern es muss möglich gemacht werden, dass
% alle Kombinationen von aufeinanderfolgenden Adjektiven möglich sind. 
% Um dies zu erreichen brauchen wir zwei neue Grammatikregeln, welche folgendermaßen aussehen:
% 1)    adjs --> [].
% 2)    adjs --> adj, adjs.
% Die erste Regel führt zu dem leeren Wort und wird verwendet, wenn in einem Satz kein Adjektiv vorkommt,
% oder um den Loop, welchen die zweite Regel auslöst, zu stoppen. 
% Mit Regel 2 ist es möglich, beliebig viele Adjektive hintereinander zu generieren.
% Nun muss diese Regel nurnoch an die richtige Stelle in die NP-Regel integriert werden,
% undzwar zwischen Determinierer und Nomen:
%       np --> det, adjs, n.

% Konjunktionen:
% Zuerst tragen wir die Konjuktionen in unser Lexikon ein.
% Konjunktionen können beliebig viele vollständige Sätze miteinander verknüpfen.
% Wir müssen also, wie zuvor bei den Adjektiven, wieder eine Rekursion in unsere Grammatikregeln einbauen.
% Der einfachste Weg wäre nun, eine neue Regel s --> s, konj, s. zu schreiben, welche
% beliebig viele Sätze miteinander verbinden kann. Dies funktioniert jedoch in der Praxis nicht, 
% da hierdurch eine Linksrekursion entsteht und die Regel bei jedem Satz loopt. 
% Diese Linksrekursion wollen wir mit Hilfe einer sogenannten "left-corner transform" vermeiden.
% Dafür unterscheiden wir zwischen zwei verschiedenen Satzarten: s und s_simple.
% s_simple bescheibt eine einfache Satzbildung durch Verknüpfung von np und vp:
%       s_simple --> np, vp.
% Die komplexere Satzbildung mit s generiert nun einen einfachen Satz bestehend aus np und vp (s_simple),
% gefolgt von einer Konjunktion und danach einem erneuten rekursiven Aufruf von s, wodurch beliebig viele weitere
% Sätze durch Konjunktionen verbunden werden können:
%       s --> s_simple, konj, s.
% Dies passiert so lange, bis folgende Regel benutzt wird, welche s einen s_simple generieren lässt:
%       s --> s_simple.
% Durch diese Konstruktion haben wir die Linksrekursion vermieden, da auf der linken Seite der Konjunktionen
% nun immer ein s_simple steht, welcher keine weiteren Sätze mit sich selbst verknüpfen kann.


%
%%% Lösung zu Aufgabe 1)

% Grammatikregeln
s --> s_simple, konj, s.    % Regel ruft sich nur auf der rechten Seite der Konjunktion rekursiv selbst auf
s --> s_simple.             % Generierung eine simplen Satzes stoppt die Rekursion von s
s_simple --> np, vp.        % s_simple generiert wie gehabt Sätze bestehend aus np und vp

np --> det, adjs, n.        % Regel zur Generierung von Adjektiven wird zwischen det und n eingesetzt

adjs --> [].                % Generierung des leeren Wortes stoppt die Rekursion der Adjektivgenerierung
adjs --> adj, adjs.         % Regel zur Generierung von Adjektiven ruft sich selbst rekursiv auf

vp --> v, np.               % Regel zur Generierung von einer VP bestehend aus einem Verb und einer NP


% Lexikon
det --> [eine].                 % eine ist ein Determinierer 
det --> [die].                  % die ist ein Determinierer 
det --> [keine].                % keine ist ein Determinierer 
n --> [maus].                   % maus ist ein Nomen
n --> [katze].                  % katze ist ein Nomen
v --> [jagt].                   % jagt ist ein Verb
v --> [klaut].                  % klaut ist ein Verb
adj --> [kleine].               % kleine ist ein Adjektiv
adj --> [schnelle].             % schnelle ist ein Adjektiv
konj --> [und].                 % und ist eine Konjunktion
konj --> [oder].                % oder ist ein Konjunktion


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                               %
% Aufgabe 2)                                                    %
% Erweitere deine Grammatik zusätzlich um                       %
%     • den Eigennamen „otto“ und/oder                          %
%     • die Pluralformen „mäuse“ und „katzen“.                  %
%                                                               %
% Implementiere deine Grammatik als DCG in Prolog. Speichere    %
% deine Grammatik in einer eigenen Datei.                       %
% Wir werden sie in den kommenden Wochen erweitern und          %
% zusätzliche Prädikate definieren, die die Arbeit mit der      %
% Grammatik vereinfachen.                                       %
%                                                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% 
%% Erläuterung zu Aufgabe 2)

% Eigennamen:
% Zuerst tragen wir den Eigennamen "otto" in unser Lexikon ein.
% Da Eigennamen keinen Determinierer brauchen, wird eine neue np-Regel erstellt, welche nur den Eigennamen generiert:
%       np --> en.

% Pluralformen:
% Zuerst tragen wir die Pluralformen von Determinierern, Nomen, Verben und Adjektiven in unser Lexikon ein.
% Singular- und Pluralformen werden jeweils mit dem entsprechenden Anhang "_sg" oder "_pl" gekennzeichnet.
% Von Eigennamen und Konjunktionen gibt es keine Pluralformen.
% Nun müssen alle Regeln, die von den Pluralformen betroffen sind, erweitert bzw. verändert werden:
% Betroffene Regeln sind alle, welche Nomen, Verben, Adjektive oder Determinierer erzeugen.
% Es gibt nun nicht mehr nur eine Version dieser Worte, sondern jeweils 2.
% All diese Regeln müssen dupliziert werden, und einmal im Singular und einmal im Plural vorhanden sein,
% jeweils aufeinander abgestimmt.
% Hierbei ist wichtig, dass jeweils der Numerus von allen Bestandteilen der NP und das Verb der VP übereinstimmen muss,
% aber die in der VP enthaltene NP einen beliebigen Numerus haben kann.
% Beispiel: [die, schnellen, katzen, jagen, eine, kleine, maus]
% "eine kleine maus" steht hier im Singular, obwohl NP und Verb des vorherigen Satzabschnittes im Plural stehen.
% Um dieses Konzept in unsere Grammatik zu übertragen, müssen wir für die NP's zwei zusätzliche Regeln definieren:
%       np --> np_sg.
%       np --> np_pl.
% Diese np-Regeln werden in die vp-Regeln integriert, was dazu führt, dass der Numerus der in der VP enthaltenen NP beliebig sein kann:
%       vp_sg --> v_sg, np.
%       vp_pl --> v_pl, np.
% Da Eigennamen immer im Singular stehen, muss bei dieser Regel lediglich "np" in "np_sg" umgewandelt werden.


%
%%% Lösung zu Aufgabe 2) 

% Grammatikregeln
s --> s_simple, konj, s.                % generiert s aus s_simple, einer Konjunktion und s
s --> s_simple.                         % generiert s aus s_simple
s_simple --> np_sg, vp_sg.              % generiert s_simple aus einer NP im Singular und einer VP im Singluar
s_simple --> np_pl, vp_pl.              % generiert s_simple aus einer NP im Plural und einer VP im Plural

np_sg --> det_sg, adjs_sg, n_sg.        % generiert np_sg aus einem Determinierer im Singular, einem Adjektiv im Singular und einem Nomen im Singular            
np_sg --> en.                           % generiert no_sg aus einem Eigennamen
np_pl --> det_pl, adjs_pl, n_pl.        % generiert np_pl aus einem Determinierer im Plurar, einem Adjektiv im Plural und einem Nomen im Plural  

np --> np_sg.                           % generiert np aus einem Nomen im Singular
np --> np_pl.                           % generiert np aus einem Nomen im Plural

adjs_sg --> [].                         % generiert adjs_sg ohne Inhalt
adjs_sg  --> adj_sg, adjs_sg.           % generiert adjs_sg aus einem Adjektiv im Singular und sich selbst

adjs_pl --> [].                         % generiert adjs_pl ohne Inhalt
adjs_pl  --> adj_pl, adjs_pl.           % generiert adjs_pl aus einem Adjektiv im Plural und sich selbst 

vp_sg --> v_sg, np.                     % generiert vp_sg aus einem Verb im Singular und einer NP
vp_pl --> v_pl, np.                     % generiert vp_pl aus einem Verb im Pluar und einer NP


% Lexikon
det_sg --> [eine].                      % eine ist ein Determinierer im Singular
det_sg --> [die].                       % die ist ein Determinierer im Singular
det_sg --> [keine].                     % keine ist ein Determinierer im Singular
det_pl --> [die].                       % die ist ein Determinierer im Plural
det_pl --> [keine].                     % keine ist ein Determinierer im Plural
n_sg --> [katze].                       % katze ist ein Nomen im Singular
n_sg --> [maus].                        % maus ist ein Nomen im Singular
n_pl --> [katzen].                      % katzen ist ein Nomen im Plural
n_pl --> [maeuse].                      % maeuse ist ein Nomen im Plural      
v_sg --> [jagt].                        % jagt ist ein Verb mit Argument im Singular
v_sg --> [klaut].                       % klaut ist ein Verb mit Argument im Singular
v_pl --> [jagen].                       % jagen ist ein Verb mit Argument im Plural
v_pl --> [klauen].                      % klauen ist ein Verb mit Argument im Plural
adj_sg --> [kleine].                    % kleine ist ein Adjektiv mit Argument im Singular
adj_sg --> [schnelle].                  % schnelle ist ein Adjektiv mit Argument im Singular
adj_pl --> [kleinen]                    % kleinen ist ein Adjektiv mit Argument im Plural
adj_pl --> [schnellen].                 % schnellen ist ein Adjektiv mit Argument im Plural
konj --> [und].                         % und ist eine Konjunktion
konj --> [oder]                         % oder ist eine Konjunktion
en --> [otto].                          % otto ist ein Eigenname
